% Minimal Polynomial Interpolation
% X is a matrix whos columns are the current solution vectors
function [s,accelStats]=MPE(X)
accelStats=[];
U=X(:,2:end)-X(:,1:(end-1));
Ukm1=U(:,1:(end-1)); %"Uk-1"
uk=U(:,end);
[Q,R]=mgs(U);
R=triu(R);
c=(R(1:(end-1),1:(end-1))\(-R(1:(end-1),end)));
if (nargout>1)
    accelStats.LS_residual=norm(R(1:(end-1),1:(end-1))*c-R(1:(end-1),end));
    accelStats.Ucn=cond(U);
    svdU=svd(U);
    accelStats.Ugap=svdU(1)/svdU(2);
    accelStats.Unorm=norm(U);
    accelStats.Upnorm=norm(pinv(U));
end
c(end+1)=1;
gam=c/sum(c);
xi=1-gam(1);
for i = 1:(length(gam)-1)
    xi(i+1)=xi(i)-gam(i+1);
end
s=X(:,1)+U*xi(:);
end
function [Q, R] = mgs(V)
n=size(V,2);
R = zeros(n,n);
for i=1:n
    R(i,i) = norm(V(:,i));
    V(:,i) = V(:,i)/R(i,i);
    if (i < n)
        for j = i+1:n
            R(i,j) = V(:,i)' * V(:,j);
            V(:,j) = V(:,j) - R(i,j) * V(:,i);
        end
    end
end
Q = V;
end