% Performs classical MDS
% D - the distance matrix
% dd - the dimension of the data
% W - not used
%
% Topologically Constrained Isometric Embedding
% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function Xe=classicalMds(D,dd,W)
N=length(D);
D2=D.^2;%D3=D2;%clear D;
D2=D2-repmat(mean(D2),[N,1]);clear D;
D2=D2-repmat(mean(D2')',[1,N]);
B=-1/2*D2;%clear D2;clear J;
opts=[];opts.display='off';opts.disp=0;
warning off
[Q,dl]=eigs(B,dd,'LM',opts);
warning on
Xe=Q*sqrt(max(real(dl),0));
Xe=Xe(:,end:-1:1);