% combines statistics from SMACOF (for intenal use only)
% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function newstat=combineSmacofStats(stat,stat2)
newstat=stat;
if (isfield(newstat,'sep')==0)
    newstat.sep=[];
end
if (isfield(newstat,'stressep')==0)
    newstat.stressep=[];
end
if (isfield(newstat,'Ssep')==0)
    newstat.Ssep=[];
end
newstat.pts=[newstat.pts stat2.pts];
newstat.sep=[newstat.sep length(newstat.res)];
newstat.res=[newstat.res,stat2.res];
newstat.stressep=[newstat.stressep length(newstat.stress)];
newstat.stress=[newstat.stress,stat2.stress];
newstat.cputime=[newstat.cputime,stat2.cputime+newstat.cputime(end)];
% newstat.MFLOPS=[newstat.MFLOPS,stat2.MFLOPS+newstat.MFLOPS(end)];
newstat.maxAlgebricError={newstat.maxAlgebricError{:} stat2.maxAlgebricError{:}};
newstat.normAlgebricError={newstat.normAlgebricError{:} stat2.normAlgebricError{:}};
newstat.yss={newstat.yss{:} stat2.yss{:}};
newstat.accelStats={newstat.accelStats{:} stat2.accelStats{:}};
newstat.stressSections={newstat.stressSections{:} stat2.stressSections{:}};
newstat.timeSections={newstat.timeSections{:} stat2.timeSections{:}};
newstat.flopsSections={newstat.flopsSections{:} stat2.flopsSections{:}};
newstat.extrapolationIdx=[newstat.extrapolationIdx(:)' stat2.extrapolationIdx(:)'+length(newstat.times(:))];
newstat.times=[newstat.times(:)' stat2.times(:)'];
if (isfield(newstat,'S')==1)
newstat.S=[newstat.S(:)' stat2.S(:)'];
newstat.Ssep=[newstat.Ssep length(newstat.S)];
end
newstat.postExtrapolationStress=[newstat.postExtrapolationStress(:)' stat2.postExtrapolationStress(:)'];