% detects boundary points using the change in the variance between axes of
% the k-nearest points neighborhood
% (for internal use only)
% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function [idx,stats]=detectBoundaryPointsN5(D,dd,K,flatten_in_advance)
idx=[];
stds=zeros(length(D),1);
stdRs=zeros(length(D),1);
sumXs=zeros(length(D),1);
sumXns=zeros(length(D),1);
if (flatten_in_advance)
    XGn=classicalMds(D,dd,ones(size(D)));
end
for i = 1:length(D)
    [dists,nidx]=sort(D(i,:));
    nidx=nidx(1:K);
    Dn=D(nidx,nidx);
if (flatten_in_advance)
    Xn=XGn(nidx,:);
else
    Xn=classicalMds(Dn,dd,ones(size(Dn)));
end
    stdC=std(Xn);
    sumXn=sum(((mean(Xn)-Xn(1,:))./stdC).^2);
    sumXns(i)=sumXn;
    
end
idx=find(sumXns>dd*(0.35));
stats.stds=stds;
stats.stdRs=stdRs;
stats.sumXs=sumXs;
end