% (for internal use only)
% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function idxs=findPathByDistance(D,TRI,start_idx)
idxs=[];
idx=start_idx;
while(1)
    idxs(end+1)=idx;
    if (D(idx)==0)
        break;
    end
    nidx=findNeighbors(TRI,idx);
    [dd,yy]=min(D(nidx));
    idx=nidx(yy); % select new neighbor
end 
return

function nidx=findNeighbors(TRI,idx)
tidx=[find(TRI(:,1)==idx);find(TRI(:,2)==idx);find(TRI(:,3)==idx)];
tidx=unique(tidx);
nidx=TRI(tidx(:),:);
nidx=unique(nidx(:));
return