%determines whether a set of points is connected in terms of their pairwise
%distance map
% D - the distance matrix
% W - the weights matrix
%
% res - set to 1 if the points are connected, 0 otherwise
%
% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function [res]=isConnected(D,W)
connected=[];
newPoints=1;
INF=inf;
ZERO=1e-4*mean(W(:));
while ~isempty(newPoints)
    nextSetDidx=find((D(newPoints,:)<INF).*(W(newPoints,:)>ZERO));
    [is,js]=ind2sub(size(D(newPoints,:)),nextSetDidx);
    unj=unique(js);
%     uni=unique(is);
newPoints=setdiff(newPoints,connected);
    connected=[connected,newPoints(:)'];
%     length(connected)
    newPoints=setdiff(unj,connected);
end
if length(connected)==length(D)
    res=1;
else
    res=0;
end
% fprintf('.');
end

