% By Guy Rosman, 2008
%
% for more details, see:
% "G. Rosman, A. M. Bronstein, M. M. Bronstein, R. Kimmel, Manifold
% Analysis by Topologically Constrained Isometric Embedding, World
% Enformatika Conference on Machine Learning and Pattern Recognition (MLPR), 2006
%
% ANY ACADEMIC USE OF THIS CODE MUST CITE THE ABOVE REFERENCES. 
% ANY COMMERCIAL USE PROHIBITED WITHOUT WRITTEN CONSENT OF THE AUTHORS. 
% PLEASE CONTACT THE AUTHORS FOR LICENSING TERMS. 
% PROTECTED BY INTERNATIONAL INTELLECTUAL PROPERTY LAWS AND PATENTS PENDING.
%
function [X,alpha]=lineSearchStress(Xold,d,D,W,idx)
s=Xold+d;
alpha=1;
f=calcStress(Xold,D,W,idx,0);
% check if we have a V-shape and if so, skip the initialization
a=0;
c=1;
while(1)
    fc=calcStress(Xold+d*c,D,W,idx,c);
    if (fc<f)
        alpha=c;
        X=Xold+c*d;
        break;
    end
    c=(a*0.2+c*0.8);
    if (c<2E-2)
        a=0;
        c=1;
        alpha=0;
        X=Xold;
        break;
    end
end
end
function f=calcStress(X,D,W,idx,alpha)
DX=L2_distance(X',X');
global mMultCnt;
global mAddCnt;
global mDivCnt;
    mMultCnt=mMultCnt+length(idx)*2;
    mAddCnt=mAddCnt+length(idx)*3;
    mDivCnt=mDivCnt+1;
f=sum(W(idx).*(D(idx)-DX(idx)).^2)/sum(W(idx));%+5E-5*(alpha-1)^2;
end